{%- import "src/_rda_template.j2" as rda_dmp_cs with context -%}
{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}


{%- set local_ns = namespace(description="distribution") -%}


{%- macro createDatasetDistribution(globals, dataset) -%}
  {#- a note of caution:  all distribution identification actually originates -#}
  {#- from physical infrastructure details asked at the very beginning of the -#}
  {#- questionnaire -#}
  {#- this could well be not optimal: a question for end-users, which might -#}
  {#- necessitate a questionnaire modification -#}

  {%- set distribution_vars = globals.global_ns.distribution_vars  -%}
  {%- set sites = distribution_vars.infrastructure_sites -%}
  {%- set nb_sites = sites|length -%}
  {%- if nb_sites > 0 -%}
    {%- for i in range(nb_sites) -%}
      {{ utils.deepCopy(rda_dmp_cs.distribution) }}
      {%- set new_distribution = utils.global_ns.var_stack.pop() -%}

      {%- if i == 0 -%}
        {%- set msg = "1rst" -%}
      {%- elif i == 1 -%}
        {%- set msg = "2nd" -%}
      {%- else -%}
        {%- set j = i + 1  -%}
        {%- set msg = j ~ "th" -%}
      {%- endif -%}
      
      {%- if not sites[i].title -%}
        {{ utils.warningMessage(false, "in createDatasetDistribution, the " ~ msg ~ " site has no name, it will be dismissed") }}
      {%- else -%}
        {%- do new_distribution.update({ "title" : sites[i].title }) -%}
        
        {%- if not sites[i].url and not distribution_vars.infrastructure_url -%}
          {{ utils.warningMessage(false, "in createDatasetDistribution, nor the " ~ msg ~ " site nor the infrastructure has an access url") }} 
          {%- do new_distribution.update({ "access_url" : none  }) -%}
        {%- elif not sites[i].url and distribution_vars.infrastructure_url -%}
          {%- do new_distribution.update({ "access_url" : distribution_vars.infrastructure_url  }) -%}
        {%- else -%}
          {%- do new_distribution.update({ "access_url" : sites[i].url  }) -%}
        {%- endif -%}

        {%- do dataset.distribution.append(new_distribution) -%}
      {%- endif -%}
    {%- endfor -%}
  {%- else -%}
    {{ utils.deepCopy(rda_dmp_cs.distribution) }}
    {%- set new_distribution = utils.global_ns.var_stack.pop() -%}
    
    {%- if not distribution_vars.infrastructure_title -%}
      {{ utils.warningMessage(false, "in createDatasetDistribution, infrastructure has no name") }}
    {%- endif -%}
    {%- do new_distribution.update({ "title" : distribution_vars.infrastructure_title }) -%}
    {%- if not distribution_vars.infrastructure_url -%}
      {{ utils.warningMessage(false, "in createDatasetDistribution, the infrastructure has no access url") }}
    {%- endif -%}
    {%- do new_distribution.update({ "access_url" : distribution_vars.infrastructure_url  }) -%}
    
    {%- do dataset.distribution.append(new_distribution) -%}
  {%- endif -%}
{%- endmacro -%}
